import time
try:
    client.sf
except:
    import omero
    client = omero.client("localhost")
    client.createSession("root","ome")

    import logging
    logging.basicConfig(level=00)


from omero.util.decorators import timeit, perf


def timeit(msg, f):
    try:
        start = time.time()
        return f()
    finally:
        stop = time.time()
        print msg, stop-start



sr = client.sf.sharedResources()
t = timeit("open", lambda: sr.openTable(omero.model.OriginalFileI(1203, False)))
cols = timeit("headers", t.getHeaders)
#timeit("read", lambda: t.read(range(len(cols)), 0, 4000))

NC = len(cols)
NR = 4000
PCT = (.1, .25, .5, .75, .9, 1)
PCT = (.33, .66, 1)
C = [int(NC*x) for x in PCT]
R = [int(NR*x) for x in PCT]

fmtc = "%4s\t"
fmt = "%4.2f\t"
print "     \t",
for c in C:
    print fmtc % c,
print

def run_once(c, r):
    """
    Run a single batch and return the time.
    """
    start = time.time()
    t.read(range(c), 0, r)
    stop = time.time()
    return stop - start

def batch(size, max):
    current = 0
    rv = []
    while current < max:
        rv.append(current)
        current += 1
        if len(rv) == size:
            yield rv
            rv = []

def run_batches(c_batch, r_batch):
    """
    Run a single batch and return the time.
    """
    elapsed = 0
    for r in batch(r_batch, NR):
        for c in batch(c_batch, NC):
            start = time.time()
            t.read(c, r[0], r[-1])
            stop = time.time()
            elapsed += (stop-start)
    return elapsed

run = run_batches

for r in R:
    print fmtc % r,
    for c in C:
        elapsed = run(c, r)
        print fmt % elapsed,
    print
